Attribute VB_Name = "modVBIDE"
'HuntERR Add-In, version 1.0, 07/06/2001
'URFIN JUS (www.urfinjus.net)
'Properties and methods for Interacting with VB IDE
Option Explicit

Public VBInstance As VBIDE.VBE
Public ideProjectName As String, ideModuleName As String, ideModuleType As Long
Public ideModuleIsExtCallable As Boolean 'True if methods are callable from outside of the component
'Module types: vbext_ct_ClassModule=2, vbext_ct_MSForm=5, vbext_ct_StdModule=1


Public Sub ReadProjectName()
    ideProjectName = ""
    On Error Resume Next
    ideProjectName = VBInstance.ActiveVBProject.Name
End Sub

Public Function RefreshModuleInfo() As Boolean
    Dim sInst As String, IsPublicClass As Boolean
    On Error GoTo errHandler
    ideModuleName = ""
    If ActiveModule Is Nothing Then Exit Function
    With ActiveModule
        ideModuleName = .Parent.Name
        ideModuleType = .Parent.Type
        sInst = ModuleProp("Instancing")
        IsPublicClass = (sInst <> "") And (InStr(1, "2,3,4,5,6", sInst) > 0)
        Select Case ideModuleType
            Case vbext_ct_ClassModule
                ideModuleIsExtCallable = IsPublicClass
            Case vbext_ct_ActiveXDesigner
                ideModuleIsExtCallable = True
            Case vbext_ct_VBForm, vbext_ct_MSForm, vbext_ct_VBMDIForm, _
                    vbext_ct_StdModule, vbext_ct_UserControl
                ideModuleIsExtCallable = False
            Case Else:
                ideModuleIsExtCallable = False
        End Select
    End With
    RefreshModuleInfo = True
    Exit Function
errHandler:
    ErrorIn "RefreshModuleInfo"
End Function

'It turns out contrary to documentation second parameter of ProcOfLine method
'is OUTPUT, not INPUT as help file states. So this function returns proc name as return value,
'and proc type as second parameter.
Public Function ReadCurrentProcInfo(ByRef AName As String, ByRef AType As vbext_ProcKind, ByRef AProcIsHandler As Boolean, _
                               ByRef AStartLine As Long, ByRef ALineCount As Long, ByRef AText As String) As Boolean
    On Error GoTo errHandler
    Dim L As Long, VarName As String
    AName = ""
    If ActiveModule Is Nothing Then Exit Function
    AName = ActiveModule.ProcOfLine(CurrentLine, AType)
    If AName <> "" Then
        With ActiveModule
            AStartLine = .procStartLine(AName, AType)
            ALineCount = .ProcCountLines(AName, AType)
            AText = .Lines(AStartLine, ALineCount)
        End With
        If (ideModuleType <> vbext_ct_StdModule) And (AType = vbext_pk_Proc) And (InStr(1, AName, "_") > 0) Then
            AProcIsHandler = True
            Else
            AProcIsHandler = False
        End If
        ReadCurrentProcInfo = True
    End If
    Exit Function
errHandler:
    ErrorIn "ReadCurrentProcInfo(AName,AType,AProcIsHandler,AStartLine,ALineCount,AText)", _
                Array(AName, AType, AProcIsHandler, AStartLine, ALineCount, AText)
End Function

'
Public Property Get CurrentLine() As Long
    Dim lngStartLine As Long, lngStartCol As Long
    Dim lngEndLine As Long, lngEndCol As Long
    On Error Resume Next
    ActivePane.GetSelection lngStartLine, lngStartCol, lngEndLine, lngEndCol
    CurrentLine = lngStartLine
End Property

Public Property Let CurrentLine(ByVal Value As Long)
    On Error Resume Next
    ActivePane.SetSelection Value, 1, Value, 1
End Property

Public Property Get CodeStartLine() As Long
    On Error Resume Next
    CodeStartLine = ActiveModule.CountOfDeclarationLines + 1
End Property

Public Sub InsertTextAt(ByVal LineNum As Long, ByVal Text As String)
    On Error Resume Next
    ActiveModule.InsertLines LineNum, Text
End Sub

Public Sub DeleteTextAt(ByVal LineNum As Long, ByVal LineCount As Long)
    On Error Resume Next
    ActiveModule.DeleteLines LineNum, LineCount
End Sub

'========================== Private stuff ===============================================

'We didn't figure out how to use Parent.ReadProperty, so here is cycle through all properties
Private Function ModuleProp(ByVal PropName As String) As String
    Dim Prop As VBIDE.Property, i As Long
    On Error GoTo errHandler
    For i = 1 To ActiveModule.Parent.Properties.Count
        Set Prop = ActiveModule.Parent.Properties(i)
        If Prop.Name = PropName Then
            ModuleProp = Prop.Value
            Exit Function
        End If
    Next i
    Exit Function
errHandler:
    ErrorIn "ModuleProp(PropName)", PropName
End Function

Public Property Get ActivePane() As CodePane
    On Error Resume Next
    Set ActivePane = VBInstance.ActiveCodePane
End Property

Public Property Get ActiveModule() As CodeModule
    On Error Resume Next
    Set ActiveModule = ActivePane.CodeModule
End Property
    

